diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/mgt-headers.h ns-3.38/src/wifi/model/mgt-headers.h
--- ns-3.37/src/wifi/model/mgt-headers.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/mgt-headers.h	2023-03-16 20:54:23.860869400 -0700
@@ -32,6 +32,7 @@
 
 #include "ns3/dsss-parameter-set.h"
 #include "ns3/eht-capabilities.h"
+#include "ns3/eht-operation.h"
 #include "ns3/erp-information.h"
 #include "ns3/he-capabilities.h"
 #include "ns3/he-operation.h"
@@ -515,6 +516,12 @@
      */
     const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
     /**
+     * Return the EHT operation, if present.
+     *
+     * \return EHT operation, if present
+     */
+    const std::optional<EhtOperation>& GetEhtOperation() const;
+    /**
      * Return the Multi-Link Element information element, if present.
      *
      * \return the Multi-Link Element information element, if present
@@ -689,6 +696,16 @@
     void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
 
     /**
+     * Set the EHT operation.
+     *
+     * \param ehtOperation HE operation
+     */
+    void SetEhtOperation(const EhtOperation& ehtOperation);
+
+    /** \copydoc SetEhtOperation */
+    void SetEhtOperation(EhtOperation&& ehtOperation);
+
+    /**
      * Set the Multi-Link Element information element
      *
      * \param multiLinkElement the Multi-Link Element information element
@@ -725,6 +742,7 @@
     std::optional<HeOperation> m_heOperation;                 //!< HE operation
     std::optional<MuEdcaParameterSet> m_muEdcaParameterSet;   //!< MU EDCA Parameter Set
     std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
+    std::optional<EhtOperation> m_ehtOperation;               //!< EHT Operation
     std::optional<MultiLinkElement> m_multiLinkElement;       //!< Multi-Link Element
 };
 
@@ -966,6 +984,12 @@
      */
     const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
     /**
+     * Return the EHT operation, if present.
+     *
+     * \return EHT operation, if present
+     */
+    const std::optional<EhtOperation>& GetEhtOperation() const;
+    /**
      * Return the ERP information, if present.
      *
      * \return the ERP information, if present
@@ -1087,6 +1111,16 @@
     void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
 
     /**
+     * Set the EHT operation.
+     *
+     * \param ehtOperation HE operation
+     */
+    void SetEhtOperation(const EhtOperation& ehtOperation);
+
+    /** \copydoc SetEhtOperation */
+    void SetEhtOperation(EhtOperation&& ehtOperation);
+
+    /**
      * Set the Service Set Identifier (SSID).
      *
      * \param ssid SSID
@@ -1178,7 +1212,7 @@
      *
      * \return time stamp
      */
-    uint64_t GetTimestamp();
+    uint64_t GetTimestamp() const;
 
     /**
      * Register this type.
@@ -1209,6 +1243,7 @@
     std::optional<EdcaParameterSet> m_edcaParameterSet;       //!< EDCA Parameter Set
     std::optional<MuEdcaParameterSet> m_muEdcaParameterSet;   //!< MU EDCA Parameter Set
     std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
+    std::optional<EhtOperation> m_ehtOperation;               //!< EHT Operation
     std::optional<ReducedNeighborReport>
         m_reducedNeighborReport;                        //!< Reduced Neighbor Report information
     std::optional<MultiLinkElement> m_multiLinkElement; //!< Multi-Link Element
@@ -1432,13 +1467,13 @@
      *
      * \return CategoryValue
      */
-    CategoryValue GetCategory();
+    CategoryValue GetCategory() const;
     /**
      * Return the action value.
      *
      * \return ActionValue
      */
-    ActionValue GetAction();
+    ActionValue GetAction() const;
 
     /**
      * Register this type.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/mpdu-aggregator.cc ns-3.38/src/wifi/model/mpdu-aggregator.cc
--- ns-3.37/src/wifi/model/mpdu-aggregator.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/mpdu-aggregator.cc	2023-03-16 20:54:23.860869400 -0700
@@ -35,6 +35,7 @@
 
 #include "ns3/he-capabilities.h"
 #include "ns3/ht-capabilities.h"
+#include "ns3/ht-frame-exchange-manager.h"
 #include "ns3/log.h"
 #include "ns3/packet.h"
 #include "ns3/vht-capabilities.h"
@@ -56,18 +57,11 @@
     return tid;
 }
 
-MpduAggregator::MpduAggregator()
-{
-}
-
-MpduAggregator::~MpduAggregator()
-{
-}
-
 void
 MpduAggregator::DoDispose()
 {
     m_mac = nullptr;
+    m_htFem = nullptr;
     Object::DoDispose();
 }
 
@@ -76,6 +70,18 @@
 {
     NS_LOG_FUNCTION(this << mac);
     m_mac = mac;
+    m_htFem = DynamicCast<HtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+}
+
+void
+MpduAggregator::SetLinkId(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << +linkId);
+    m_linkId = linkId;
+    if (m_mac)
+    {
+        m_htFem = DynamicCast<HtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+    }
 }
 
 void
@@ -137,7 +143,7 @@
         return 0;
     }
 
-    Ptr<WifiRemoteStationManager> stationManager = m_mac->GetWifiRemoteStationManager();
+    Ptr<WifiRemoteStationManager> stationManager = m_mac->GetWifiRemoteStationManager(m_linkId);
     NS_ASSERT(stationManager);
 
     // Retrieve the Capabilities elements advertised by the recipient
@@ -206,12 +212,13 @@
     Mac48Address recipient = mpdu->GetHeader().GetAddr1();
     NS_ASSERT(mpdu->GetHeader().IsQosData() && !recipient.IsBroadcast());
     uint8_t tid = mpdu->GetHeader().GetQosTid();
+    auto origRecipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
 
     Ptr<QosTxop> qosTxop = m_mac->GetQosTxop(tid);
     NS_ASSERT(qosTxop);
 
     // Have to make sure that the block ack agreement is established and A-MPDU is enabled
-    if (qosTxop->GetBaAgreementEstablished(recipient, tid) &&
+    if (m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid) &&
         GetMaxAmpduSize(recipient, tid, txParams.m_txVector.GetModulationClass()) > 0)
     {
         /* here is performed MPDU aggregation */
@@ -228,25 +235,24 @@
             mpduList.push_back(nextMpdu);
 
             // If allowed by the BA agreement, get the next MPDU
-            auto peekedMpdu = qosTxop->PeekNextMpdu(SINGLE_LINK_OP_ID, tid, recipient, nextMpdu);
+            auto peekedMpdu =
+                qosTxop->PeekNextMpdu(m_linkId, tid, origRecipient, nextMpdu->GetOriginal());
             nextMpdu = nullptr;
 
             if (peekedMpdu)
             {
                 // PeekNextMpdu() does not return an MPDU that is beyond the transmit window
                 NS_ASSERT(IsInWindow(peekedMpdu->GetHeader().GetSequenceNumber(),
-                                     qosTxop->GetBaStartingSequence(recipient, tid),
-                                     qosTxop->GetBaBufferSize(recipient, tid)));
+                                     qosTxop->GetBaStartingSequence(origRecipient, tid),
+                                     qosTxop->GetBaBufferSize(origRecipient, tid)));
 
+                peekedMpdu = m_htFem->CreateAliasIfNeeded(peekedMpdu);
                 // get the next MPDU to aggregate, provided that the constraints on size
                 // and duration limit are met. Note that the returned MPDU differs from
                 // the peeked MPDU if A-MSDU aggregation is enabled.
                 NS_LOG_DEBUG("Trying to aggregate another MPDU");
-                nextMpdu = qosTxop->GetNextMpdu(SINGLE_LINK_OP_ID,
-                                                peekedMpdu,
-                                                txParams,
-                                                availableTime,
-                                                false);
+                nextMpdu =
+                    qosTxop->GetNextMpdu(m_linkId, peekedMpdu, txParams, availableTime, false);
             }
         }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/mpdu-aggregator.h ns-3.38/src/wifi/model/mpdu-aggregator.h
--- ns-3.37/src/wifi/model/mpdu-aggregator.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/mpdu-aggregator.h	2023-03-16 20:54:23.860869400 -0700
@@ -38,6 +38,7 @@
 class WifiMac;
 class WifiMpdu;
 class WifiTxParameters;
+class HtFrameExchangeManager;
 
 /**
  * \brief Aggregator used to construct A-MPDUs
@@ -57,8 +58,8 @@
      */
     static TypeId GetTypeId();
 
-    MpduAggregator();
-    ~MpduAggregator() override;
+    MpduAggregator() = default;
+    ~MpduAggregator() override = default;
 
     /**
      * Aggregate an MPDU to an A-MPDU.
@@ -70,6 +71,13 @@
     static void Aggregate(Ptr<const WifiMpdu> mpdu, Ptr<Packet> ampdu, bool isSingle);
 
     /**
+     * Set the ID of the link this MPDU aggregator is associated with.
+     *
+     * \param linkId the ID of the link this MPDU aggregator is associated with
+     */
+    void SetLinkId(uint8_t linkId);
+
+    /**
      * Compute the size of the A-MPDU resulting from the aggregation of an MPDU of
      * size <i>mpduSize</i> and an A-MPDU of size <i>ampduSize</i>.
      *
@@ -158,7 +166,9 @@
     void DoDispose() override;
 
   private:
-    Ptr<WifiMac> m_mac; //!< the MAC of this station
+    Ptr<WifiMac> m_mac;                  //!< the MAC of this station
+    Ptr<HtFrameExchangeManager> m_htFem; //!< the HT Frame Exchange Manager of this station
+    uint8_t m_linkId{0};                 //!< ID of the link this object is connected to
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/msdu-aggregator.cc ns-3.38/src/wifi/model/msdu-aggregator.cc
--- ns-3.37/src/wifi/model/msdu-aggregator.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/msdu-aggregator.cc	2023-03-16 20:54:23.860869400 -0700
@@ -51,14 +51,6 @@
     return tid;
 }
 
-MsduAggregator::MsduAggregator()
-{
-}
-
-MsduAggregator::~MsduAggregator()
-{
-}
-
 void
 MsduAggregator::DoDispose()
 {
@@ -72,7 +64,18 @@
 {
     NS_LOG_FUNCTION(this << mac);
     m_mac = mac;
-    m_htFem = DynamicCast<HtFrameExchangeManager>(m_mac->GetFrameExchangeManager());
+    m_htFem = DynamicCast<HtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+}
+
+void
+MsduAggregator::SetLinkId(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << +linkId);
+    m_linkId = linkId;
+    if (m_mac)
+    {
+        m_htFem = DynamicCast<HtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+    }
 }
 
 uint16_t
@@ -94,7 +97,7 @@
     Ptr<WifiMacQueue> queue = m_mac->GetTxopQueue(peekedItem->GetQueueAc());
 
     uint8_t tid = peekedItem->GetHeader().GetQosTid();
-    Mac48Address recipient = peekedItem->GetHeader().GetAddr1();
+    auto recipient = peekedItem->GetOriginal()->GetHeader().GetAddr1();
 
     /* "The Address 1 field of an MPDU carrying an A-MSDU shall be set to an
      * individual address or to the GCR concealment address" (Section 10.12
@@ -120,15 +123,18 @@
         return nullptr;
     }
 
-    Ptr<WifiMpdu> amsdu = peekedItem;
+    Ptr<WifiMpdu> amsdu = queue->GetOriginal(peekedItem);
     uint8_t nMsdu = 1;
-    peekedItem = queue->PeekByTidAndAddress(tid, recipient, peekedItem);
+    peekedItem = queue->PeekByTidAndAddress(tid, recipient, peekedItem->GetOriginal());
 
-    while (peekedItem && m_htFem->TryAggregateMsdu(peekedItem, txParams, availableTime))
+    while (peekedItem &&
+           m_htFem->TryAggregateMsdu(peekedItem = m_htFem->CreateAliasIfNeeded(peekedItem),
+                                     txParams,
+                                     availableTime))
     {
         // find the next MPDU before dequeuing the current one
-        Ptr<const WifiMpdu> msdu = peekedItem;
-        peekedItem = queue->PeekByTidAndAddress(tid, recipient, peekedItem);
+        Ptr<const WifiMpdu> msdu = peekedItem->GetOriginal();
+        peekedItem = queue->PeekByTidAndAddress(tid, recipient, msdu);
         queue->DequeueIfQueued({amsdu});
         // perform A-MSDU aggregation
         amsdu->Aggregate(msdu);
@@ -144,7 +150,7 @@
     }
 
     // Aggregation succeeded
-    return amsdu;
+    return m_htFem->CreateAliasIfNeeded(amsdu);
 }
 
 uint8_t
@@ -171,13 +177,27 @@
         return 0;
     }
 
-    Ptr<WifiRemoteStationManager> stationManager = m_mac->GetWifiRemoteStationManager();
+    Ptr<WifiRemoteStationManager> stationManager = m_mac->GetWifiRemoteStationManager(m_linkId);
     NS_ASSERT(stationManager);
 
     // Retrieve the Capabilities elements advertised by the recipient
-    Ptr<const VhtCapabilities> vhtCapabilities =
-        stationManager->GetStationVhtCapabilities(recipient);
-    Ptr<const HtCapabilities> htCapabilities = stationManager->GetStationHtCapabilities(recipient);
+    auto ehtCapabilities = stationManager->GetStationEhtCapabilities(recipient);
+    auto vhtCapabilities = stationManager->GetStationVhtCapabilities(recipient);
+    auto htCapabilities = stationManager->GetStationHtCapabilities(recipient);
+
+    // Determine the maximum MPDU size, which is used to indirectly constrain the maximum
+    // A-MSDU size in some cases (see below). The maximum MPDU size is advertised
+    // in the EHT Capabilities element, for the 2.4 GHz band, or in the VHT Capabilities
+    // element, otherwise.
+    uint16_t maxMpduSize = 0;
+    if (ehtCapabilities && m_mac->GetWifiPhy(m_linkId)->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ)
+    {
+        maxMpduSize = ehtCapabilities->GetMaxMpduLength();
+    }
+    else if (vhtCapabilities && m_mac->GetWifiPhy(m_linkId)->GetPhyBand() != WIFI_PHY_BAND_2_4GHZ)
+    {
+        maxMpduSize = vhtCapabilities->GetMaxMpduLength();
+    }
 
     if (!htCapabilities)
     {
@@ -192,29 +212,49 @@
 
     // Determine the constraint imposed by the recipient based on the PPDU
     // format used to transmit the A-MSDU
-    if (modulation >= WIFI_MOD_CLASS_VHT)
+    if (modulation >= WIFI_MOD_CLASS_EHT)
+    {
+        // the maximum A-MSDU size is indirectly constrained by the maximum MPDU size
+        // supported by the recipient (see Table 9-34 of 802.11be D2.0)
+        NS_ABORT_MSG_IF(maxMpduSize == 0, "Max MPDU size not advertised");
+        maxAmsduSize = std::min(maxAmsduSize, static_cast<uint16_t>(maxMpduSize - 56));
+    }
+    else if (modulation == WIFI_MOD_CLASS_HE)
+    {
+        // for a non-EHT STA operating in the 2.4 GHz band, the maximum A-MSDU size is
+        // advertised in the HT Capabilities element. Otherwise, the maximum A-MSDU size is
+        // indirectly constrained by the maximum MPDU size supported by the recipient
+        // (see Table 9-34 of 802.11be D2.0)
+        if (m_mac->GetWifiPhy(m_linkId)->GetStandard() < WIFI_STANDARD_80211be &&
+            m_mac->GetWifiPhy(m_linkId)->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ)
+        {
+            maxAmsduSize = std::min(maxAmsduSize, htCapabilities->GetMaxAmsduLength());
+        }
+        else
+        {
+            NS_ABORT_MSG_IF(maxMpduSize == 0, "Max MPDU size not advertised");
+            maxAmsduSize = std::min(maxAmsduSize, static_cast<uint16_t>(maxMpduSize - 56));
+        }
+    }
+    else if (modulation == WIFI_MOD_CLASS_VHT)
     {
         // the maximum A-MSDU size is indirectly constrained by the maximum MPDU
         // size supported by the recipient and advertised in the VHT Capabilities
-        // element (see Table 9-19 of 802.11-2016 as amended by 802.11ax)
-        NS_ABORT_MSG_IF(!vhtCapabilities, "VHT Capabilities element not received");
-
-        maxAmsduSize =
-            std::min(maxAmsduSize, static_cast<uint16_t>(vhtCapabilities->GetMaxMpduLength() - 56));
+        // element (see Table 9-25 of 802.11-2020)
+        NS_ABORT_MSG_IF(maxMpduSize == 0, "Max MPDU size not advertised");
+        maxAmsduSize = std::min(maxAmsduSize, static_cast<uint16_t>(maxMpduSize - 56));
     }
-    else if (modulation == WIFI_MOD_CLASS_HT)
+    else if (modulation >= WIFI_MOD_CLASS_HT)
     {
         // the maximum A-MSDU size is constrained by the maximum A-MSDU size
         // supported by the recipient and advertised in the HT Capabilities
         // element (see Table 9-19 of 802.11-2016)
-
         maxAmsduSize = std::min(maxAmsduSize, htCapabilities->GetMaxAmsduLength());
     }
     else // non-HT PPDU
     {
         // the maximum A-MSDU size is indirectly constrained by the maximum PSDU size
         // supported by the recipient (see Table 9-19 of 802.11-2016)
-
         maxAmsduSize = std::min(maxAmsduSize, static_cast<uint16_t>(3839));
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/msdu-aggregator.h ns-3.38/src/wifi/model/msdu-aggregator.h
--- ns-3.37/src/wifi/model/msdu-aggregator.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/msdu-aggregator.h	2023-03-16 20:54:23.860869400 -0700
@@ -55,8 +55,15 @@
      */
     static TypeId GetTypeId();
 
-    MsduAggregator();
-    ~MsduAggregator() override;
+    MsduAggregator() = default;
+    ~MsduAggregator() override = default;
+
+    /**
+     * Set the ID of the link this MSDU aggregator is associated with.
+     *
+     * \param linkId the ID of the link this MSDU aggregator is associated with
+     */
+    void SetLinkId(uint8_t linkId);
 
     /**
      * Compute the size of the A-MSDU resulting from the aggregation of an MSDU of
@@ -148,6 +155,7 @@
   private:
     Ptr<WifiMac> m_mac;                  //!< the MAC of this station
     Ptr<HtFrameExchangeManager> m_htFem; //!< the HT Frame Exchange Manager of this station
+    uint8_t m_linkId{0};                 //!< ID of the link this object is connected to
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/dsss-error-rate-model.cc ns-3.38/src/wifi/model/non-ht/dsss-error-rate-model.cc
--- ns-3.37/src/wifi/model/non-ht/dsss-error-rate-model.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/dsss-error-rate-model.cc	2023-03-16 20:54:23.860869400 -0700
@@ -23,6 +23,13 @@
 
 #include <cmath>
 
+#ifdef HAVE_GSL
+#include <gsl/gsl_cdf.h>
+#include <gsl/gsl_integration.h>
+#include <gsl/gsl_math.h>
+#include <gsl/gsl_sf_bessel.h>
+#endif
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/dsss-error-rate-model.h ns-3.38/src/wifi/model/non-ht/dsss-error-rate-model.h
--- ns-3.37/src/wifi/model/non-ht/dsss-error-rate-model.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/dsss-error-rate-model.h	2023-03-16 20:54:23.860869400 -0700
@@ -20,13 +20,6 @@
 #ifndef DSSS_ERROR_RATE_MODEL_H
 #define DSSS_ERROR_RATE_MODEL_H
 
-#ifdef HAVE_GSL
-#include <gsl/gsl_cdf.h>
-#include <gsl/gsl_integration.h>
-#include <gsl/gsl_math.h>
-#include <gsl/gsl_sf_bessel.h>
-#endif
-
 #include <cstdint>
 
 namespace ns3
@@ -36,11 +29,11 @@
 /**
  * Structure for integral function parameters
  */
-typedef struct FunctionParameterType
+struct FunctionParameters
 {
     double beta; ///< Beta parameter
     double n;    ///< n parameter
-} FunctionParameters;
+};
 
 /**
  * Integral function using GSL library
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/dsss-phy.cc ns-3.38/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.37/src/wifi/model/non-ht/dsss-phy.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/dsss-phy.cc	2023-03-16 20:54:23.860869400 -0700
@@ -49,7 +49,7 @@
                              WIFI_PPDU_FIELD_DATA } },
     { WIFI_PREAMBLE_SHORT, { WIFI_PPDU_FIELD_PREAMBLE,      // Short PHY preamble
                              WIFI_PPDU_FIELD_NON_HT_HEADER, // Short PHY header
-                             WIFI_PPDU_FIELD_DATA } }
+                             WIFI_PPDU_FIELD_DATA } },
 };
 
 const PhyEntity::ModulationLookupTable DsssPhy::m_dsssModulationLookupTable {
@@ -57,7 +57,7 @@
   { "DsssRate1Mbps",   { WIFI_CODE_RATE_UNDEFINED, 2 } },
   { "DsssRate2Mbps",   { WIFI_CODE_RATE_UNDEFINED, 4 } },
   { "DsssRate5_5Mbps", { WIFI_CODE_RATE_UNDEFINED, 16 } },
-  { "DsssRate11Mbps",  { WIFI_CODE_RATE_UNDEFINED, 256 } }
+  { "DsssRate11Mbps",  { WIFI_CODE_RATE_UNDEFINED, 256 } },
 };
 
 // clang-format on
@@ -265,10 +265,9 @@
 }
 
 Ptr<SpectrumValue>
-DsssPhy::GetTxPowerSpectralDensity(double txPowerW,
-                                   Ptr<const WifiPpdu> /* ppdu */,
-                                   const WifiTxVector& txVector) const
+DsssPhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
 {
+    const auto& txVector = ppdu->GetTxVector();
     uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
     uint16_t channelWidth = txVector.GetChannelWidth();
     NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/dsss-phy.h ns-3.38/src/wifi/model/non-ht/dsss-phy.h
--- ns-3.37/src/wifi/model/non-ht/dsss-phy.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/dsss-phy.h	2023-03-16 20:54:23.860869400 -0700
@@ -161,8 +161,7 @@
   private:
     PhyFieldRxStatus DoEndReceiveField(WifiPpduField field, Ptr<Event> event) override;
     Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
-                                                 Ptr<const WifiPpdu> ppdu,
-                                                 const WifiTxVector& txVector) const override;
+                                                 Ptr<const WifiPpdu> ppdu) const override;
     uint16_t GetRxChannelWidth(const WifiTxVector& txVector) const override;
     uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/dsss-ppdu.cc ns-3.38/src/wifi/model/non-ht/dsss-ppdu.cc
--- ns-3.37/src/wifi/model/non-ht/dsss-ppdu.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/dsss-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
@@ -40,13 +40,31 @@
     : WifiPpdu(psdu, txVector, txCenterFreq, uid)
 {
     NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << ppduDuration << uid);
-    m_dsssSig.SetRate(txVector.GetMode().GetDataRate(22));
-    Time psduDuration = ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
-    m_dsssSig.SetLength(psduDuration.GetMicroSeconds());
+    SetPhyHeaders(txVector, ppduDuration);
 }
 
-DsssPpdu::~DsssPpdu()
+void
+DsssPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
 {
+    NS_LOG_FUNCTION(this << txVector);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    DsssSigHeader dsssSig;
+    SetDsssHeader(dsssSig, txVector, ppduDuration);
+    m_phyHeaders->AddHeader(dsssSig);
+#else
+    SetDsssHeader(m_dsssSig, txVector, ppduDuration);
+#endif
+}
+
+void
+DsssPpdu::SetDsssHeader(DsssSigHeader& dsssSig,
+                        const WifiTxVector& txVector,
+                        Time ppduDuration) const
+{
+    dsssSig.SetRate(txVector.GetMode().GetDataRate(22));
+    Time psduDuration = ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
+    dsssSig.SetLength(psduDuration.GetMicroSeconds());
 }
 
 WifiTxVector
@@ -54,25 +72,50 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-    txVector.SetMode(DsssPhy::GetDsssRate(m_dsssSig.GetRate()));
     txVector.SetChannelWidth(22);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    DsssSigHeader dsssSig;
+    if (m_phyHeaders->PeekHeader(dsssSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing DSSS SIG PHY header in DSSS PPDU");
+    }
+
+    SetTxVectorFromDsssHeader(txVector, dsssSig);
+#else
+    SetTxVectorFromDsssHeader(txVector, m_dsssSig);
+#endif
+
     return txVector;
 }
 
+void
+DsssPpdu::SetTxVectorFromDsssHeader(WifiTxVector& txVector, const DsssSigHeader& dsssSig) const
+{
+    txVector.SetMode(DsssPhy::GetDsssRate(dsssSig.GetRate()));
+}
+
 Time
 DsssPpdu::GetTxDuration() const
 {
     Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
-    ppduDuration = MicroSeconds(m_dsssSig.GetLength()) +
-                   WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
+    uint16_t length = 0;
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    DsssSigHeader dsssSig;
+    m_phyHeaders->PeekHeader(dsssSig);
+    length = dsssSig.GetLength();
+#else
+    length = m_dsssSig.GetLength();
+#endif
+    ppduDuration = MicroSeconds(length) + WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
     return ppduDuration;
 }
 
 Ptr<WifiPpdu>
 DsssPpdu::Copy() const
 {
-    return Create<DsssPpdu>(GetPsdu(), GetTxVector(), m_txCenterFreq, GetTxDuration(), m_uid);
+    return Ptr<WifiPpdu>(new DsssPpdu(*this), false);
 }
 
 DsssPpdu::DsssSigHeader::DsssSigHeader()
@@ -81,10 +124,6 @@
 {
 }
 
-DsssPpdu::DsssSigHeader::~DsssSigHeader()
-{
-}
-
 TypeId
 DsssPpdu::DsssSigHeader::GetTypeId()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/dsss-ppdu.h ns-3.38/src/wifi/model/non-ht/dsss-ppdu.h
--- ns-3.37/src/wifi/model/non-ht/dsss-ppdu.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/dsss-ppdu.h	2023-03-16 20:54:23.860869400 -0700
@@ -53,7 +53,6 @@
     {
       public:
         DsssSigHeader();
-        ~DsssSigHeader() override;
 
         /**
          * \brief Get the type ID.
@@ -111,10 +110,6 @@
              uint16_t txCenterFreq,
              Time ppduDuration,
              uint64_t uid);
-    /**
-     * Destructor for DsssPpdu.
-     */
-    ~DsssPpdu() override;
 
     Time GetTxDuration() const override;
     Ptr<WifiPpdu> Copy() const override;
@@ -122,8 +117,38 @@
   private:
     WifiTxVector DoGetTxVector() const override;
 
+    /**
+     * Fill in the PHY headers.
+     *
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
+
+    /**
+     * Fill in the DSSS header.
+     *
+     * \param dsssSig the DSSS header to fill in
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    void SetDsssHeader(DsssSigHeader& dsssSig,
+                       const WifiTxVector& txVector,
+                       Time ppduDuration) const;
+
+    /**
+     * Fill in the TXVECTOR from DSSS header.
+     *
+     * \param txVector the TXVECTOR to fill in
+     * \param dsssSig the DSSS header
+     */
+    virtual void SetTxVectorFromDsssHeader(WifiTxVector& txVector,
+                                           const DsssSigHeader& dsssSig) const;
+
+#ifndef NS3_BUILD_PROFILE_DEBUG
     DsssSigHeader m_dsssSig; //!< the DSSS SIG PHY header
-};                           // class DsssPpdu
+#endif
+}; // class DsssPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.38/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.37/src/wifi/model/non-ht/erp-ofdm-phy.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/erp-ofdm-phy.cc	2023-03-16 20:54:23.860869400 -0700
@@ -113,12 +113,14 @@
                       Time /* ppduDuration */)
 {
     NS_LOG_FUNCTION(this << psdus << txVector);
-    return Create<ErpOfdmPpdu>(psdus.begin()->second,
-                               txVector,
-                               m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-                                   txVector.GetChannelWidth()),
-                               m_wifiPhy->GetPhyBand(),
-                               ObtainNextUid(txVector));
+    return Create<ErpOfdmPpdu>(
+        psdus.begin()->second,
+        txVector,
+        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
+            txVector.GetChannelWidth()),
+        m_wifiPhy->GetPhyBand(),
+        m_wifiPhy->GetLatestPhyEntity()->ObtainNextUid(
+            txVector)); // use latest PHY entity to handle MU-RTS sent with non-HT rate
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/erp-ofdm-ppdu.cc ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.cc
--- ns-3.37/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
@@ -35,30 +35,22 @@
                          uint16_t txCenterFreq,
                          WifiPhyBand band,
                          uint64_t uid)
-    : OfdmPpdu(psdu, txVector, txCenterFreq, band, uid, true) // instantiate LSigHeader of OfdmPpdu
+    : OfdmPpdu(psdu, txVector, txCenterFreq, band, uid, true) // add LSigHeader of OfdmPpdu
 {
     NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << band << uid);
 }
 
-ErpOfdmPpdu::~ErpOfdmPpdu()
+void
+ErpOfdmPpdu::SetTxVectorFromLSigHeader(WifiTxVector& txVector, const LSigHeader& lSig) const
 {
-}
-
-WifiTxVector
-ErpOfdmPpdu::DoGetTxVector() const
-{
-    WifiTxVector txVector;
-    txVector.SetPreambleType(m_preamble);
-    NS_ASSERT(m_channelWidth == 20);
-    txVector.SetMode(ErpOfdmPhy::GetErpOfdmRate(m_lSig.GetRate()));
-    txVector.SetChannelWidth(m_channelWidth);
-    return txVector;
+    txVector.SetMode(ErpOfdmPhy::GetErpOfdmRate(lSig.GetRate()));
+    txVector.SetChannelWidth(20);
 }
 
 Ptr<WifiPpdu>
 ErpOfdmPpdu::Copy() const
 {
-    return Create<ErpOfdmPpdu>(GetPsdu(), GetTxVector(), m_txCenterFreq, m_band, m_uid);
+    return Ptr<WifiPpdu>(new ErpOfdmPpdu(*this), false);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/erp-ofdm-ppdu.h ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.h
--- ns-3.37/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2023-03-16 20:54:23.860869400 -0700
@@ -58,15 +58,11 @@
                 uint16_t txCenterFreq,
                 WifiPhyBand band,
                 uint64_t uid);
-    /**
-     * Destructor for ErpOfdmPpdu.
-     */
-    ~ErpOfdmPpdu() override;
 
     Ptr<WifiPpdu> Copy() const override;
 
   private:
-    WifiTxVector DoGetTxVector() const override;
+    void SetTxVectorFromLSigHeader(WifiTxVector& txVector, const LSigHeader& lSig) const override;
 }; // class ErpOfdmPpdu
 
 } // namespace ns3
